/* ****************************************************************
** @(#)SortedList.java	1.3 97/03/25
**
** Copyright 1997 Sun Microsystems, Inc. All Rights Reserved
**
** ****************************************************************
*/

import java.io.*;
import java.util.Vector;

public class SortedList {

  private FileInputStream fin;
  private FileOutputStream fout;
  private Vector items;

  public SortedList() {
    items = new Vector();
  }

  public Listable getItem(int key) {

    int count=items.size();
    if (key>=count)
      return null;
    ListItem l=(ListItem)items.elementAt(key);
    return (Listable)l.obj.clone();
  }

   public int putItem(String key, ListItem item) {
      int i=0;
      int count=items.size();
      boolean found = false;

      while(i<count) {
	if (((ListItem)items.elementAt(i)).key.toLowerCase().compareTo(key.toLowerCase())>0) {
	  items.insertElementAt(item,i);
	  found=true;
	  break;
	}
	i++;
      }
      if (!found) {
	items.addElement(item);
	return items.size()-1;
      } else {
	return i;
      }
   }

  public void removeItem(int key) {
    int count=size();
    if (key> -1 && key<count)
      items.removeElementAt(key);
  }

  public int size() {
    return items.size();
  }

   public String[] getKeys() {
      int i = 0;
      int j = 0;
      String[] names;
      names = new String[size()];
      for (i=0;i<size();i++) {
	names[j++] = ((ListItem)items.elementAt(i)).key;
      }
      return names;
   }

  public void load(File filename, Listable obj) {
    boolean more = true;
    Listable newitem;
    FileInputStream fin = null;
    DataInputStream din = null;
    String dataline = null;

    try {
      fin  = new FileInputStream(filename);
      din  = new DataInputStream(fin);

      while (more) {
	
	newitem = obj.read_from_file(din);
	if (newitem != null) {
	  ListItem l;
	  l = new ListItem();
	  l.key = new String(newitem.getKey());
	  l.obj = newitem;
	  putItem(l.key,l);
	}
	else {
	  more = false;
	}
      }
      din.close();
      fin.close();
    }
    catch (IOException e) {
      System.out.println("IOException open: " + e.getMessage());
    }
  }

  public void save(File filename){
    try {
      PrintStream pout=new PrintStream(new FileOutputStream(filename));
      for(int i=0;i<size();i++) {
	((ListItem)items.elementAt(i)).obj.write_to_file(pout);
      }
      pout.close();
    }
    catch (IOException e) {
      System.out.println("IOException save: "+e.getMessage());
    }
  }

}
