/* ****************************************************************
**  @(#)TelephoneTF.java	1.2 97/06/05
**
** Copyright 1997 Sun Microsystems, Inc. All Rights Reserved
**
** ****************************************************************
*/

import java.awt.event.KeyListener;
import java.awt.TextField;
import java.awt.event.KeyEvent;
import java.util.Vector;

public class TelephoneTF extends TextField implements KeyListener {

  public TelephoneTF(int cols){
    super(cols);
    addKeyListener(this);
  }

  public void setText(String s){
    StringBuffer sb = new StringBuffer();
    for(int i=0;i<s.length();i++){
	char c = s.charAt(i);
	if(isValid(c))sb.append(c);
        if(c==')')sb.append('-');
    }
    super.setText(sb.toString());
  }

  public void keyTyped(KeyEvent e){}
  public void keyPressed(KeyEvent e){
    char c = e.getKeyChar();
    if(isValid(c))return;
    if((c==8)||(c==127)||(c==0))return;
    e.consume();
  }
  public void keyReleased(KeyEvent e){}
  

  /** the minimum requirement for a valid-looking phone number */
  public boolean isValid(){
    String[] s = getFields();
    if(s.length<2)return false;
    if(s.length>5)return false;
    for(int i=0;i<s.length;i++){
	int fl = s[i].length();
	if((fl<1)||(fl>8))return false;
    }
    String n = getNumber();
    for(int i=0;i<n.length();i++){
	char c= n.charAt(i);
	if((c<'0')||(c>'9'))return false;
    }
    return true;
  }

  /** returns the fields between the dashes 
   * (e.g. "415-555-1212" becomes {"415","555","1212"} ) */
  public String[] getFields(){
    Vector v = new Vector();
    String s = getText();
    int last = 0;
    int next = s.indexOf('-',last);
    while(next!=-1){
      v.addElement(s.substring(last,next));
      last = next+1;
      next = s.indexOf('-',last);
    }
    v.addElement(s.substring(last));
    String[] r = new String[v.size()];
    v.copyInto(r);
    return r;
  }

  /** returns the number without the dashes; (long would lose leading zeros) */
  public String getNumber(){
    String [] sa = getFields();
    String x = "";
    for(int i=0;i<sa.length;i++){
	x = x+sa[i];
    }
    return numbersOnly(x);
  }


  public static boolean isValid(char c){
    return (((c>='0')&&(c<='9'))||(c=='-')||(validAlpha.indexOf(c)>-1));
  }

  public static final String validAlpha = "ABCDEFGHIJKLMNOPRSTUVWXY";
  public static final String alphaValue = "222333444555666777888999";

  public static String numbersOnly(String in){
    for(int i=0;i<in.length();i++){
      char c = in.charAt(i);
      int idx = validAlpha.indexOf(c);
      if(idx>-1){
	in = in.replace(c,alphaValue.charAt(idx));
      }
    }
    return in;
  }

}
